* This UDF calls itself recursively.        John Wright

FUNCTION NUM2TEXT
* Convert numbers to text - does not support decimals in this version.
* Ex. 15 = "Fifteen ";  52 = "Fifty-two ";  101 = "One Hundred One "
PARAMETER chk_num
STORE INT(chk_num) TO chk_num
PRIVATE chk_list,chk_it,chk_out
DO CASE
 CASE chk_num < 0
  RETURN "Negative "+NUM2TEXT(chk_num*-1)
 CASE chk_num < 11
  chk_list="Zero One  Two  ThreeFour Five Six  SevenEightNine Ten  "
  RETURN TRIM(SUBSTR(chk_list,(chk_num*5)+1,5))+" "
 CASE chk_num < 20
  chk_list="Eleven   Twelve   Thirteen Fourteen Fifteen  "+;
           "Sixteen  SeventeenEighteen Nineteen "
  RETURN TRIM(SUBSTR(chk_list,((chk_num-11)*9)+1,9))+" "
 CASE chk_num < 30
  RETURN "Twenty"+IF(chk_num>20,"-"+NUM2TEXT(chk_num-20)," ")
 CASE chk_num < 40
  RETURN "Thirty"+IF(chk_num>30,"-"+NUM2TEXT(chk_num-30)," ")
 CASE chk_num < 50
  RETURN "Forty"+IF(chk_num>40,"-"+NUM2TEXT(chk_num-40)," ")
 CASE chk_num < 60
  RETURN "Fifty"+IF(chk_num>50,"-"+NUM2TEXT(chk_num-50)," ")
 CASE chk_num < 70
  RETURN "Sixty"+IF(chk_num>60,"-"+NUM2TEXT(chk_num-60)," ")
 CASE chk_num < 80
  RETURN "Seventy"+IF(chk_num>70,"-"+NUM2TEXT(chk_num-70)," ")
 CASE chk_num < 90
  RETURN "Eighty"+IF(chk_num>80,"-"+NUM2TEXT(chk_num-80)," ")
 CASE chk_num < 100
  RETURN "Ninety"+IF(chk_num>90,"-"+NUM2TEXT(chk_num-90)," ")
 CASE chk_num < 1000
  chk_it=INT(chk_num/100)
  chk_out=chk_num-(chk_it*100)
  RETURN NUM2TEXT(chk_it)+"Hundred"+IF(chk_out>0," "+NUM2TEXT(chk_out)," ")
 CASE chk_num < 1000000
  chk_it=INT(chk_num/1000)
  chk_out=chk_num-(chk_it*1000)
  RETURN NUM2TEXT(chk_it)+"Thousand"+IF(chk_out>0,", "+NUM2TEXT(chk_out)," ")
 CASE chk_num < 1000000000
  chk_it=INT(chk_num/1000000)
  chk_out=chk_num-(chk_it*1000000)
  RETURN NUM2TEXT(chk_it)+"Million"+IF(chk_out>0,", "+NUM2TEXT(chk_out)," ")
 CASE chk_num < 1000000000000
  chk_it=INT(chk_num/1000000000)
  chk_out=chk_num-(chk_it*1000000000)
  RETURN NUM2TEXT(chk_it)+"Billion"+IF(chk_out>0,", "+NUM2TEXT(chk_out)," ")
OTHERWISE
 * if not handled above then display a message
 RETURN "** Number not translated **"
ENDCASE

